From bb3ff5d34e064311d5d97c33b516655012421d4c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 16 2020 04:38:24 +0000
Subject: [PATCH 1423/2232] Add Rust constructor for pinned CxxString on stack


---

diff --git a/src/cxx.cc b/src/cxx.cc
index 1295d04..423f72e 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -9,6 +9,16 @@
 #include <vector>
 
 extern "C" {
+void cxxbridge05$cxx_string$init(std::string *s, const uint8_t *ptr,
+                                 size_t len) noexcept {
+  new (s) std::string(reinterpret_cast<const char *>(ptr), len);
+}
+
+void cxxbridge05$cxx_string$destroy(std::string *s) noexcept {
+  using std::string;
+  s->~string();
+}
+
 const char *cxxbridge05$cxx_string$data(const std::string &s) noexcept {
   return s.data();
 }
@@ -230,6 +240,11 @@ void cxxbridge05$unique_ptr$std$string$drop(
 }
 } // extern "C"
 
+static_assert(alignof(std::string) <= alignof(void *),
+              "unexpectedly large std::string alignment");
+static_assert(sizeof(std::string) <= 8 * sizeof(void *),
+              "unexpectedly large std::string size");
+
 #define STD_VECTOR_OPS(RUST_TYPE, CXX_TYPE)                                    \
   size_t cxxbridge05$std$vector$##RUST_TYPE##$size(                            \
       const std::vector<CXX_TYPE> &s) noexcept {                               \
diff --git a/src/cxx_string.rs b/src/cxx_string.rs
index 273905e..7a66b47 100644
--- a/src/cxx_string.rs
+++ b/src/cxx_string.rs
@@ -1,12 +1,18 @@
+use crate::actually_private::Private;
 use alloc::borrow::Cow;
 use alloc::string::String;
 use core::fmt::{self, Debug, Display};
 use core::marker::{PhantomData, PhantomPinned};
+use core::mem::MaybeUninit;
 use core::pin::Pin;
 use core::slice;
 use core::str::{self, Utf8Error};
 
 extern "C" {
+    #[link_name = "cxxbridge05$cxx_string$init"]
+    fn string_init(this: &mut MaybeUninit<CxxString>, ptr: *const u8, len: usize);
+    #[link_name = "cxxbridge05$cxx_string$destroy"]
+    fn string_destroy(this: &mut MaybeUninit<CxxString>);
     #[link_name = "cxxbridge05$cxx_string$data"]
     fn string_data(this: &CxxString) -> *const u8;
     #[link_name = "cxxbridge05$cxx_string$length"]
@@ -31,7 +37,53 @@ pub struct CxxString {
     _pinned: PhantomData<PhantomPinned>,
 }
 
+/// Construct a C++ std::string on the Rust stack.
+///
+/// # Syntax
+///
+/// In statement position:
+///
+/// ```
+/// # use cxx::let_cxx_string;
+/// # let expression = "";
+/// let_cxx_string!(var = expression);
+/// ```
+///
+/// The `expression` may have any type that implements `AsRef<[u8]>`. Commonly
+/// it will be a string literal, but for example `&[u8]` and `String` would work
+/// as well.
+///
+/// The macro expands to something resembling `let $var: Pin<&mut CxxString> =
+/// /*???*/;`. The resulting [`Pin`] can be deref'd to `&CxxString` as needed.
+///
+/// # Example
+///
+/// ```
+/// use cxx::{let_cxx_string, CxxString};
+///
+/// fn f(s: &CxxString) {/* ... */}
+///
+/// fn main() {
+///     let_cxx_string!(s = "example");
+///     f(&s);
+/// }
+/// ```
+#[macro_export]
+macro_rules! let_cxx_string {
+    ($var:ident = $value:expr $(,)?) => {
+        let mut $var = $crate::private::StackString::new();
+        #[allow(unused_mut, unused_unsafe)]
+        let mut $var = unsafe { $var.init($value) };
+    };
+}
+
 impl CxxString {
+    /// `CxxString` is not constructible via `new`. Instead, use the
+    /// [`let_cxx_string!`] macro.
+    pub fn new<T: Private>() -> Self {
+        unreachable!()
+    }
+
     /// Returns the length of the string in bytes.
     ///
     /// Matches the behavior of C++ [std::string::size][size].
@@ -128,3 +180,35 @@ impl PartialEq<str> for CxxString {
         self.as_bytes() == other.as_bytes()
     }
 }
+
+#[doc(hidden)]
+#[repr(C)]
+pub struct StackString {
+    // Static assertions in cxx.cc validate that this is large enough and
+    // aligned enough.
+    space: MaybeUninit<[*const (); 8]>,
+}
+
+impl StackString {
+    pub fn new() -> Self {
+        StackString {
+            space: MaybeUninit::uninit(),
+        }
+    }
+
+    pub unsafe fn init(&mut self, value: impl AsRef<[u8]>) -> Pin<&mut CxxString> {
+        let value = value.as_ref();
+        let this = &mut *self.space.as_mut_ptr().cast::<MaybeUninit<CxxString>>();
+        string_init(this, value.as_ptr(), value.len());
+        Pin::new_unchecked(&mut *this.as_mut_ptr())
+    }
+}
+
+impl Drop for StackString {
+    fn drop(&mut self) {
+        unsafe {
+            let this = &mut *self.space.as_mut_ptr().cast::<MaybeUninit<CxxString>>();
+            string_destroy(this);
+        }
+    }
+}
diff --git a/src/lib.rs b/src/lib.rs
index 5a03ebf..7a6dcf9 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -426,6 +426,7 @@ pub type Vector<T> = CxxVector<T>;
 // Not public API.
 #[doc(hidden)]
 pub mod private {
+    pub use crate::cxx_string::StackString;
     pub use crate::cxx_vector::VectorElement;
     pub use crate::extern_type::{verify_extern_kind, verify_extern_type};
     pub use crate::function::FatFunction;
@@ -439,6 +440,10 @@ pub mod private {
     pub use crate::unwind::catch_unwind;
 }
 
+mod actually_private {
+    pub trait Private {}
+}
+
 macro_rules! chars {
     ($($ch:ident)*) => {
         $(

